org.apache.catalina.core

## Class ApplicationContextFacade

- java.lang.Object
- - org.apache.catalina.core.ApplicationContextFacade

All Implemented Interfaces:
  ServletContext

    public class ApplicationContextFacade
    extends Object
    implements ServletContext

Facade object which masks the internal `ApplicationContext` object from the web application.

Author:
  Remy Maucherat, Jean-Francois Arcand

### Field Summary

### Fields inherited from interface javax.servlet.ServletContext

`ORDERED_LIBS, TEMPDIR`

### Constructor Summary

Constructors
Constructor and Description
`ApplicationContextFacade(ApplicationContext context)` Construct a new instance of this class, associated with the specified Context instance.

### Method Summary

Methods
`FilterRegistration.Dynamic` `addFilter(String filterName, Class<? extends Filter> filterClass)`
`FilterRegistration.Dynamic` `addFilter(String filterName, Filter filter)`
`FilterRegistration.Dynamic` `addFilter(String filterName, String className)`
`void` `addListener(Class<? extends EventListener> listenerClass)`
`void` `addListener(String className)`
`<T extends EventListener> void` `addListener(T t)`
`ServletRegistration.Dynamic` `addServlet(String servletName, Class<? extends Servlet> servletClass)`
`ServletRegistration.Dynamic` `addServlet(String servletName, Servlet servlet)`
`ServletRegistration.Dynamic` `addServlet(String servletName, String className)`
`<T extends Filter> T` `createFilter(Class<T> c)`
`<T extends EventListener> T` `createListener(Class<T> c)`
`<T extends Servlet> T` `createServlet(Class<T> c)`
`void` `declareRoles(String... roleNames)`
`Object` `getAttribute(String name)` Returns the servlet container attribute with the given name, or `null` if there is no attribute by that name.
`Enumeration<String>` `getAttributeNames()` Returns an `Enumeration` containing the attribute names available within this servlet context.
`ClassLoader` `getClassLoader()`
`ServletContext` `getContext(String uripath)` Returns a `ServletContext` object that corresponds to a specified URL on the server.
`String` `getContextPath()`
`Set<SessionTrackingMode>` `getDefaultSessionTrackingModes()`
`int` `getEffectiveMajorVersion()`
`int` `getEffectiveMinorVersion()`
`Set<SessionTrackingMode>` `getEffectiveSessionTrackingModes()`
`FilterRegistration` `getFilterRegistration(String filterName)`
`Map<String,? extends FilterRegistration>` `getFilterRegistrations()`
`String` `getInitParameter(String name)` Returns a `String` containing the value of the named context-wide initialization parameter, or `null` if the parameter does not exist.
`Enumeration<String>` `getInitParameterNames()` Returns the names of the context's initialization parameters as an `Enumeration` of `String` objects, or an empty `Enumeration` if the context has no initialization parameters.
`JspConfigDescriptor` `getJspConfigDescriptor()`
`int` `getMajorVersion()` Returns the major version of the Java Servlet API that this servlet container supports.
`String` `getMimeType(String file)` Returns the MIME type of the specified file, or `null` if the MIME type is not known.
`int` `getMinorVersion()` Returns the minor version of the Servlet API that this servlet container supports.
`RequestDispatcher` `getNamedDispatcher(String name)` Returns a `RequestDispatcher` object that acts as a wrapper for the named servlet.
`String` `getRealPath(String path)` Returns a `String` containing the real path for a given virtual path.
`RequestDispatcher` `getRequestDispatcher(String path)` Returns a `RequestDispatcher` object that acts as a wrapper for the resource located at the given path.
`URL` `getResource(String path)` Returns a URL to the resource that is mapped to a specified path.
`InputStream` `getResourceAsStream(String path)` Returns the resource located at the named path as an `InputStream` object.
`Set<String>` `getResourcePaths(String path)` Returns a directory-like listing of all the paths to resources within the web application whose longest sub-path matches the supplied path argument.
`String` `getServerInfo()` Returns the name and version of the servlet container on which the servlet is running.
`Servlet` `getServlet(String name)` Deprecated. As of Java Servlet API 2.1, with no direct replacement.
`String` `getServletContextName()` Returns the name of this web application corresponding to this ServletContext as specified in the deployment descriptor for this web application by the display-name element.
`Enumeration<String>` `getServletNames()` Deprecated. As of Java Servlet API 2.1, with no direct replacement.
`ServletRegistration` `getServletRegistration(String servletName)` Obtain the details of the named servlet.
`Map<String,? extends ServletRegistration>` `getServletRegistrations()`
`Enumeration<Servlet>` `getServlets()` Deprecated. As of Java Servlet API 2.1, with no direct replacement.
`SessionCookieConfig` `getSessionCookieConfig()`
`void` `log(Exception exception, String msg)` Deprecated. As of Java Servlet API 2.1, use `log(String, Throwable)` instead
`void` `log(String msg)` Writes the specified message to a servlet log file, usually an event log.
`void` `log(String message, Throwable throwable)` Writes an explanatory message and a stack trace for a given `Throwable` exception to the servlet log file.
`void` `removeAttribute(String name)` Removes the attribute with the given name from the servlet context.
`void` `setAttribute(String name, Object object)` Binds an object to a given attribute name in this servlet context.
`boolean` `setInitParameter(String name, String value)`
`void` `setSessionTrackingModes(Set<SessionTrackingMode> sessionTrackingModes)`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### ApplicationContextFacade

    public ApplicationContextFacade(ApplicationContext context)

Construct a new instance of this class, associated with the specified Context instance.

Parameters:
  `context` - The associated Context instance

### Method Detail

#### getContext

    public ServletContext getContext(String uripath)

Description copied from interface: `javax.servlet.ServletContext`
Returns a `ServletContext` object that corresponds to a specified URL on the server.

This method allows servlets to gain access to the context for various parts of the server, and as needed obtain `RequestDispatcher` objects from the context. The given path must be begin with "/", is interpreted relative to the server's document root and is matched against the context roots of other web applications hosted on this container.

In a security conscious environment, the servlet container may return `null` for a given URL.

Specified by:
  `getContext` in interface `ServletContext`
Parameters:
  `uripath` - a `String` specifying the context path of another web application in the container.
Returns:
  the `ServletContext` object that corresponds to the named URL, or null if either none exists or the container wishes to restrict this access.
See Also:
  `RequestDispatcher`

#### getMajorVersion

    public int getMajorVersion()

Description copied from interface: `javax.servlet.ServletContext`
Returns the major version of the Java Servlet API that this servlet container supports. All implementations that comply with Version 3.0 must have this method return the integer 3.

Specified by:
  `getMajorVersion` in interface `ServletContext`
Returns:
  3

#### getMinorVersion

    public int getMinorVersion()

Description copied from interface: `javax.servlet.ServletContext`
Returns the minor version of the Servlet API that this servlet container supports. All implementations that comply with Version 3.0 must have this method return the integer 0.

Specified by:
  `getMinorVersion` in interface `ServletContext`
Returns:
  0

#### getMimeType

    public String getMimeType(String file)

Description copied from interface: `javax.servlet.ServletContext`
Returns the MIME type of the specified file, or `null` if the MIME type is not known. The MIME type is determined by the configuration of the servlet container, and may be specified in a web application deployment descriptor. Common MIME types are `"text/html"` and `"image/gif"`.

Specified by:
  `getMimeType` in interface `ServletContext`
Parameters:
  `file` - a `String` specifying the name of a file
Returns:
  a `String` specifying the file's MIME type

#### getResourcePaths

    public Set<String> getResourcePaths(String path)

Description copied from interface: `javax.servlet.ServletContext`
Returns a directory-like listing of all the paths to resources within the web application whose longest sub-path matches the supplied path argument. Paths indicating subdirectory paths end with a '/'. The returned paths are all relative to the root of the web application and have a leading '/'. For example, for a web application containing
/welcome.html
/catalog/index.html
/catalog/products.html
/catalog/offers/books.html
/catalog/offers/music.html
/customer/login.jsp
/WEB-INF/web.xml
/WEB-INF/classes/com.acme.OrderServlet.class,
getResourcePaths("/") returns {"/welcome.html", "/catalog/", "/customer/", "/WEB-INF/"}
getResourcePaths("/catalog/") returns {"/catalog/index.html", "/catalog/products.html", "/catalog/offers/"}.

Specified by:
  `getResourcePaths` in interface `ServletContext`
Parameters:
  `path` - the partial path used to match the resources, which must start with a /
Returns:
  a Set containing the directory listing, or null if there are no resources in the web application whose path begins with the supplied path.

#### getResource

    public URL getResource(String path)
                    throws MalformedURLException

Description copied from interface: `javax.servlet.ServletContext`
Returns a URL to the resource that is mapped to a specified path. The path must begin with a "/" and is interpreted as relative to the current context root.

This method allows the servlet container to make a resource available to servlets from any source. Resources can be located on a local or remote file system, in a database, or in a `.war` file.

The servlet container must implement the URL handlers and `URLConnection` objects that are necessary to access the resource.

This method returns `null` if no resource is mapped to the pathname.

Some containers may allow writing to the URL returned by this method using the methods of the URL class.

The resource content is returned directly, so be aware that requesting a `.jsp` page returns the JSP source code. Use a `RequestDispatcher` instead to include results of an execution.

This method has a different purpose than `java.lang.Class.getResource`, which looks up resources based on a class loader. This method does not use class loaders.

Specified by:
  `getResource` in interface `ServletContext`
Parameters:
  `path` - a `String` specifying the path to the resource
Returns:
  the resource located at the named path, or `null` if there is no resource at that path
Throws:
  `MalformedURLException` - if the pathname is not given in the correct form

#### getResourceAsStream

    public InputStream getResourceAsStream(String path)

Description copied from interface: `javax.servlet.ServletContext`
Returns the resource located at the named path as an `InputStream` object.

The data in the `InputStream` can be of any type or length. The path must be specified according to the rules given in `getResource`. This method returns `null` if no resource exists at the specified path.

Meta-information such as content length and content type that is available via `getResource` method is lost when using this method.

The servlet container must implement the URL handlers and `URLConnection` objects necessary to access the resource.

This method is different from `java.lang.Class.getResourceAsStream`, which uses a class loader. This method allows servlet containers to make a resource available to a servlet from any location, without using a class loader.

Specified by:
  `getResourceAsStream` in interface `ServletContext`
Parameters:
  `path` - a `String` specifying the path to the resource
Returns:
  the `InputStream` returned to the servlet, or `null` if no resource exists at the specified path

#### getRequestDispatcher

    public RequestDispatcher getRequestDispatcher(String path)

Description copied from interface: `javax.servlet.ServletContext`
Returns a `RequestDispatcher` object that acts as a wrapper for the resource located at the given path. A `RequestDispatcher` object can be used to forward a request to the resource or to include the resource in a response. The resource can be dynamic or static.

The pathname must begin with a "/" and is interpreted as relative to the current context root. Use `getContext` to obtain a `RequestDispatcher` for resources in foreign contexts. This method returns `null` if the `ServletContext` cannot return a `RequestDispatcher`.

Specified by:
  `getRequestDispatcher` in interface `ServletContext`
Parameters:
  `path` - a `String` specifying the pathname to the resource
Returns:
  a `RequestDispatcher` object that acts as a wrapper for the resource at the specified path, or `null` if the `ServletContext` cannot return a `RequestDispatcher`
See Also:
  `RequestDispatcher`, `ServletContext.getContext(java.lang.String)`

#### getNamedDispatcher

    public RequestDispatcher getNamedDispatcher(String name)

Description copied from interface: `javax.servlet.ServletContext`
Returns a `RequestDispatcher` object that acts as a wrapper for the named servlet.

Servlets (and JSP pages also) may be given names via server administration or via a web application deployment descriptor. A servlet instance can determine its name using `ServletConfig.getServletName()`.

This method returns `null` if the `ServletContext` cannot return a `RequestDispatcher` for any reason.

Specified by:
  `getNamedDispatcher` in interface `ServletContext`
Parameters:
  `name` - a `String` specifying the name of a servlet to wrap
Returns:
  a `RequestDispatcher` object that acts as a wrapper for the named servlet, or `null` if the `ServletContext` cannot return a `RequestDispatcher`
See Also:
  `RequestDispatcher`, `ServletContext.getContext(java.lang.String)`, `ServletConfig.getServletName()`

#### getServlet

    @Deprecated
    public Servlet getServlet(String name)
                       throws ServletException

Deprecated. As of Java Servlet API 2.1, with no direct replacement.

Specified by:
  `getServlet` in interface `ServletContext`
Throws:
  `ServletException`

#### getServlets

    @Deprecated
    public Enumeration<Servlet> getServlets()

Deprecated. As of Java Servlet API 2.1, with no direct replacement.

Specified by:
  `getServlets` in interface `ServletContext`

#### getServletNames

    @Deprecated
    public Enumeration<String> getServletNames()

Deprecated. As of Java Servlet API 2.1, with no direct replacement.

Specified by:
  `getServletNames` in interface `ServletContext`

#### log

    public void log(String msg)

Description copied from interface: `javax.servlet.ServletContext`
Writes the specified message to a servlet log file, usually an event log. The name and type of the servlet log file is specific to the servlet container.

Specified by:
  `log` in interface `ServletContext`
Parameters:
  `msg` - a `String` specifying the message to be written to the log file

#### log

    @Deprecated
    public void log(Exception exception,
                      String msg)

Deprecated. As of Java Servlet API 2.1, use `log(String, Throwable)` instead

Specified by:
  `log` in interface `ServletContext`

#### log

    public void log(String message,
           Throwable throwable)

Description copied from interface: `javax.servlet.ServletContext`
Writes an explanatory message and a stack trace for a given `Throwable` exception to the servlet log file. The name and type of the servlet log file is specific to the servlet container, usually an event log.

Specified by:
  `log` in interface `ServletContext`
Parameters:
  `message` - a `String` that describes the error or exception
  `throwable` - the `Throwable` error or exception

#### getRealPath

    public String getRealPath(String path)

Description copied from interface: `javax.servlet.ServletContext`
Returns a `String` containing the real path for a given virtual path. For example, the path "/index.html" returns the absolute file path on the server's filesystem would be served by a request for "http://host/contextPath/index.html", where contextPath is the context path of this ServletContext..

The real path returned will be in a form appropriate to the computer and operating system on which the servlet container is running, including the proper path separators. This method returns `null` if the servlet container cannot translate the virtual path to a real path for any reason (such as when the content is being made available from a `.war` archive).

Specified by:
  `getRealPath` in interface `ServletContext`
Parameters:
  `path` - a `String` specifying a virtual path
Returns:
  a `String` specifying the real path, or null if the translation cannot be performed

#### getServerInfo

    public String getServerInfo()

Description copied from interface: `javax.servlet.ServletContext`
Returns the name and version of the servlet container on which the servlet is running.

The form of the returned string is servername/versionnumber. For example, the JavaServer Web Development Kit may return the string `JavaServer Web Dev Kit/1.0`.

The servlet container may return other optional information after the primary string in parentheses, for example, `JavaServer Web Dev Kit/1.0 (JDK 1.1.6; Windows NT 4.0 x86)`.

Specified by:
  `getServerInfo` in interface `ServletContext`
Returns:
  a `String` containing at least the servlet container name and version number

#### getInitParameter

    public String getInitParameter(String name)

Description copied from interface: `javax.servlet.ServletContext`
Returns a `String` containing the value of the named context-wide initialization parameter, or `null` if the parameter does not exist.

This method can make available configuration information useful to an entire "web application". For example, it can provide a webmaster's email address or the name of a system that holds critical data.

Specified by:
  `getInitParameter` in interface `ServletContext`
Parameters:
  `name` - a `String` containing the name of the parameter whose value is requested
Returns:
  a `String` containing the value of the initialization parameter
See Also:
  `ServletConfig.getInitParameter(java.lang.String)`

#### getInitParameterNames

    public Enumeration<String> getInitParameterNames()

Description copied from interface: `javax.servlet.ServletContext`
Returns the names of the context's initialization parameters as an `Enumeration` of `String` objects, or an empty `Enumeration` if the context has no initialization parameters.

Specified by:
  `getInitParameterNames` in interface `ServletContext`
Returns:
  an `Enumeration` of `String` objects containing the names of the context's initialization parameters
See Also:
  `ServletConfig.getInitParameter(java.lang.String)`

#### getAttribute

    public Object getAttribute(String name)

Description copied from interface: `javax.servlet.ServletContext`
Returns the servlet container attribute with the given name, or `null` if there is no attribute by that name. An attribute allows a servlet container to give the servlet additional information not already provided by this interface. See your server documentation for information about its attributes. A list of supported attributes can be retrieved using `getAttributeNames`.

The attribute is returned as a `java.lang.Object` or some subclass. Attribute names should follow the same convention as package names. The Java Servlet API specification reserves names matching `java.*`, `javax.*`, and `sun.*`.

Specified by:
  `getAttribute` in interface `ServletContext`
Parameters:
  `name` - a `String` specifying the name of the attribute
Returns:
  an `Object` containing the value of the attribute, or `null` if no attribute exists matching the given name
See Also:
  `ServletContext.getAttributeNames()`

#### getAttributeNames

    public Enumeration<String> getAttributeNames()

Description copied from interface: `javax.servlet.ServletContext`
Returns an `Enumeration` containing the attribute names available within this servlet context. Use the `ServletContext.getAttribute(java.lang.String)` method with an attribute name to get the value of an attribute.

Specified by:
  `getAttributeNames` in interface `ServletContext`
Returns:
  an `Enumeration` of attribute names
See Also:
  `ServletContext.getAttribute(java.lang.String)`

#### setAttribute

    public void setAttribute(String name,
                    Object object)

Description copied from interface: `javax.servlet.ServletContext`
Binds an object to a given attribute name in this servlet context. If the name specified is already used for an attribute, this method will replace the attribute with the new to the new attribute.

If listeners are configured on the `ServletContext` the container notifies them accordingly.

If a null value is passed, the effect is the same as calling `removeAttribute()`.

Attribute names should follow the same convention as package names. The Java Servlet API specification reserves names matching `java.*`, `javax.*`, and `sun.*`.

Specified by:
  `setAttribute` in interface `ServletContext`
Parameters:
  `name` - a `String` specifying the name of the attribute
  `object` - an `Object` representing the attribute to be bound

#### removeAttribute

    public void removeAttribute(String name)

Description copied from interface: `javax.servlet.ServletContext`
Removes the attribute with the given name from the servlet context. After removal, subsequent calls to `ServletContext.getAttribute(java.lang.String)` to retrieve the attribute's value will return `null`.

If listeners are configured on the `ServletContext` the container notifies them accordingly.

Specified by:
  `removeAttribute` in interface `ServletContext`
Parameters:
  `name` - a `String` specifying the name of the attribute to be removed

#### getServletContextName

    public String getServletContextName()

Description copied from interface: `javax.servlet.ServletContext`
Returns the name of this web application corresponding to this ServletContext as specified in the deployment descriptor for this web application by the display-name element.

Specified by:
  `getServletContextName` in interface `ServletContext`
Returns:
  The name of the web application or null if no name has been declared in the deployment descriptor.

#### getContextPath

    public String getContextPath()

Specified by:
  `getContextPath` in interface `ServletContext`

#### addFilter

    public FilterRegistration.Dynamic addFilter(String filterName,
                                       String className)

Specified by:
  `addFilter` in interface `ServletContext`
Returns:
  TODO

#### addFilter

    public FilterRegistration.Dynamic addFilter(String filterName,
                                       Filter filter)

Specified by:
  `addFilter` in interface `ServletContext`
Returns:
  TODO

#### addFilter

    public FilterRegistration.Dynamic addFilter(String filterName,
                                       Class<? extends Filter> filterClass)

Specified by:
  `addFilter` in interface `ServletContext`
Returns:
  TODO

#### createFilter

    public <T extends Filter> T createFilter(Class<T> c)
                                  throws ServletException

Specified by:
  `createFilter` in interface `ServletContext`
Returns:
  TODO
Throws:
  `ServletException`

#### getFilterRegistration

    public FilterRegistration getFilterRegistration(String filterName)

Specified by:
  `getFilterRegistration` in interface `ServletContext`
Returns:
  TODO

#### addServlet

    public ServletRegistration.Dynamic addServlet(String servletName,
                                         String className)

Specified by:
  `addServlet` in interface `ServletContext`
Returns:
  TODO

#### addServlet

    public ServletRegistration.Dynamic addServlet(String servletName,
                                         Servlet servlet)

Specified by:
  `addServlet` in interface `ServletContext`
Returns:
  TODO

#### addServlet

    public ServletRegistration.Dynamic addServlet(String servletName,
                                         Class<? extends Servlet> servletClass)

Specified by:
  `addServlet` in interface `ServletContext`
Returns:
  TODO

#### createServlet

    public <T extends Servlet> T createServlet(Class<T> c)
                                    throws ServletException

Specified by:
  `createServlet` in interface `ServletContext`
Returns:
  TODO
Throws:
  `ServletException`

#### getServletRegistration

    public ServletRegistration getServletRegistration(String servletName)

Description copied from interface: `javax.servlet.ServletContext`
Obtain the details of the named servlet.

Specified by:
  `getServletRegistration` in interface `ServletContext`
Parameters:
  `servletName` - The name of the Servlet of interest
Returns:
  The registration details for the named Servlet or `null` if no Servlet has been registered with the given name

#### getDefaultSessionTrackingModes

    public Set<SessionTrackingMode> getDefaultSessionTrackingModes()

Specified by:
  `getDefaultSessionTrackingModes` in interface `ServletContext`
Returns:
  TODO

#### getEffectiveSessionTrackingModes

    public Set<SessionTrackingMode> getEffectiveSessionTrackingModes()

Specified by:
  `getEffectiveSessionTrackingModes` in interface `ServletContext`
Returns:
  TODO

#### getSessionCookieConfig

    public SessionCookieConfig getSessionCookieConfig()

Specified by:
  `getSessionCookieConfig` in interface `ServletContext`
Returns:
  TODO

#### setSessionTrackingModes

    public void setSessionTrackingModes(Set<SessionTrackingMode> sessionTrackingModes)

Specified by:
  `setSessionTrackingModes` in interface `ServletContext`

#### setInitParameter

    public boolean setInitParameter(String name,
                           String value)

Specified by:
  `setInitParameter` in interface `ServletContext`
Returns:
  TODO

#### addListener

    public void addListener(Class<? extends EventListener> listenerClass)

Specified by:
  `addListener` in interface `ServletContext`

#### addListener

    public void addListener(String className)

Specified by:
  `addListener` in interface `ServletContext`

#### addListener

    public <T extends EventListener> void addListener(T t)

Specified by:
  `addListener` in interface `ServletContext`

#### createListener

    public <T extends EventListener> T createListener(Class<T> c)
                                           throws ServletException

Specified by:
  `createListener` in interface `ServletContext`
Returns:
  TODO
Throws:
  `ServletException`

#### declareRoles

    public void declareRoles(String... roleNames)

Specified by:
  `declareRoles` in interface `ServletContext`

#### getClassLoader

    public ClassLoader getClassLoader()

Specified by:
  `getClassLoader` in interface `ServletContext`
Returns:
  TODO

#### getEffectiveMajorVersion

    public int getEffectiveMajorVersion()

Specified by:
  `getEffectiveMajorVersion` in interface `ServletContext`
Returns:
  TODO

#### getEffectiveMinorVersion

    public int getEffectiveMinorVersion()

Specified by:
  `getEffectiveMinorVersion` in interface `ServletContext`
Returns:
  TODO

#### getFilterRegistrations

    public Map<String,? extends FilterRegistration> getFilterRegistrations()

Specified by:
  `getFilterRegistrations` in interface `ServletContext`
Returns:
  TODO

#### getJspConfigDescriptor

    public JspConfigDescriptor getJspConfigDescriptor()

Specified by:
  `getJspConfigDescriptor` in interface `ServletContext`
Returns:
  TODO

#### getServletRegistrations

    public Map<String,? extends ServletRegistration> getServletRegistrations()

Specified by:
  `getServletRegistrations` in interface `ServletContext`
Returns:
  TODO